Index: XIOS/trunk/src/transformation/axis_algorithm_inverse.cpp
===================================================================
--- XIOS/trunk/src/transformation/axis_algorithm_inverse.cpp	(revision 828)
+++ XIOS/trunk/src/transformation/axis_algorithm_inverse.cpp	(revision 829)
@@ -72,19 +72,21 @@
   std::map<int, std::vector<double> >& transWeight = this->transformationWeight_[0];
 
-  std::map<size_t, std::vector<std::pair<size_t,double> > > globaIndexMapFromDestToSource;
+  CTransformationMapping::DestinationIndexMap globaIndexMapFromDestToSource;
   std::map<int, std::vector<int> >::const_iterator it = transMap.begin(), ite = transMap.end();
+  int localIndex = 0;
   for (; it != ite; ++it)
   {
-    globaIndexMapFromDestToSource[it->first].push_back(make_pair((it->second)[0], (transWeight[it->first])[0]));
+    globaIndexMapFromDestToSource[it->first].push_back(make_pair(localIndex,make_pair((it->second)[0], (transWeight[it->first])[0])));
+    ++localIndex;
   }
 
   transformationMap.computeTransformationMapping(globaIndexMapFromDestToSource);
 
-  const std::map<int,std::vector<std::vector<std::pair<size_t,double> > > >& globalIndexToReceive = transformationMap.getGlobalIndexReceivedOnGridDestMapping();
-  const std::map<int,std::vector<size_t> >& globalIndexToSend = transformationMap.getGlobalIndexSendToGridDestMapping();
+  const CTransformationMapping::ReceivedIndexMap& globalIndexToReceive = transformationMap.getGlobalIndexReceivedOnGridDestMapping();
+  const CTransformationMapping::SentIndexMap& globalIndexToSend = transformationMap.getGlobalIndexSendToGridDestMapping();
 
  // Sending global index of original grid source
-  std::map<int,std::vector<size_t> >::const_iterator itbSend = globalIndexToSend.begin(), itSend,
-                                                     iteSend = globalIndexToSend.end();
+  CTransformationMapping::SentIndexMap::const_iterator itbSend = globalIndexToSend.begin(), itSend,
+                                                       iteSend = globalIndexToSend.end();
  int sendBuffSize = 0;
  for (itSend = itbSend; itSend != iteSend; ++itSend) sendBuffSize += (itSend->second).size();
@@ -99,9 +101,9 @@
  {
    int destRank = itSend->first;
-   const std::vector<size_t>& globalIndexOfCurrentGridSourceToSend = itSend->second;
+   const std::vector<std::pair<int,size_t> >& globalIndexOfCurrentGridSourceToSend = itSend->second;
    int countSize = globalIndexOfCurrentGridSourceToSend.size();
    for (int idx = 0; idx < (countSize); ++idx)
    {
-     int index = globalIndexOfCurrentGridSourceToSend[idx] - ibeginSrc;
+     int index = globalIndexOfCurrentGridSourceToSend[idx].first;
      sendBuff[idx+currentBuffPosition] = (axisSrc_->value)(index);
    }
@@ -112,6 +114,6 @@
 
  // Receiving global index of grid source sending from current grid source
- std::map<int,std::vector<std::vector<std::pair<size_t,double> > > >::const_iterator itbRecv = globalIndexToReceive.begin(), itRecv,
-                                                                                     iteRecv = globalIndexToReceive.end();
+ CTransformationMapping::ReceivedIndexMap::const_iterator itbRecv = globalIndexToReceive.begin(), itRecv,
+                                                          iteRecv = globalIndexToReceive.end();
  int recvBuffSize = 0;
  for (itRecv = itbRecv; itRecv != iteRecv; ++itRecv) recvBuffSize += (itRecv->second).size();
Index: XIOS/trunk/src/transformation/axis_algorithm_transformation.cpp
===================================================================
--- XIOS/trunk/src/transformation/axis_algorithm_transformation.cpp	(revision 828)
+++ XIOS/trunk/src/transformation/axis_algorithm_transformation.cpp	(revision 829)
@@ -49,6 +49,6 @@
                                                                           const std::vector<int>& gridDestGlobalDim,
                                                                           const std::vector<int>& gridSrcGlobalDim,
-                                                                          const std::vector<size_t>& globalIndexGridDestSendToServer,
-                                                                          CArray<size_t,1>& globalIndexDestGrid,
+                                                                          const GlobalLocalMap& globalLocalIndexDestSendToServerMap,
+                                                                          std::vector<std::pair<size_t,int> >& globalLocalIndexDestMap,
                                                                           std::vector<std::vector<size_t> >& globalIndexSrcGrid)
 {
@@ -72,6 +72,5 @@
   }
 
-  std::vector<size_t>::const_iterator itbArr = globalIndexGridDestSendToServer.begin(), itArr,
-                                      iteArr = globalIndexGridDestSendToServer.end();
+  GlobalLocalMap::const_iterator iteArr = globalLocalIndexDestSendToServerMap.end(), it;
 
   while (idx < ssize)
@@ -111,11 +110,11 @@
     }
 
-    if (std::binary_search(itbArr, iteArr, globIndex)) ++realGlobalIndexSize;
+    if (iteArr != globalLocalIndexDestSendToServerMap.find(globIndex)) ++realGlobalIndexSize;
     ++idxLoop[0];
     ++idx;
   }
 
-  if (globalIndexDestGrid.numElements() != realGlobalIndexSize)
-    globalIndexDestGrid.resize(realGlobalIndexSize);
+  if (globalLocalIndexDestMap.size() != realGlobalIndexSize)
+    globalLocalIndexDestMap.resize(realGlobalIndexSize);
 
   if (realGlobalIndexSize != globalIndexSrcGrid.size()) globalIndexSrcGrid.resize(realGlobalIndexSize);
@@ -162,7 +161,8 @@
     }
 
-    if (std::binary_search(itbArr, iteArr, globIndex))
+    it = globalLocalIndexDestSendToServerMap.find(globIndex);
+    if (iteArr != it)
     {
-      globalIndexDestGrid(realGlobalIndex) = globIndex;
+      globalLocalIndexDestMap[realGlobalIndex] = (std::make_pair(it->first,it->second));
       for (int i = 0; i < globalIndexSrcGrid[realGlobalIndex].size(); ++i)
       {
@@ -183,105 +183,4 @@
     ++idx;
   }
-
-
-
-//  int globalDim = gridDestGlobalDim.size();
-//
-//  std::vector<size_t> currentIndex(globalDim);
-//  std::vector<int> gridAxisGlobalDim(globalDim);
-//  std::vector<int> idxLoop(globalDim, 0);
-//
-//  size_t ssize = 1, idx = 0, realGlobalIndexSize = 0;
-//  for (int i = 0; i< globalDim; ++i)
-//  {
-//    if (axisPositionInGrid == i) gridAxisGlobalDim[i] = 1;
-//    else gridAxisGlobalDim[i] = gridDestGlobalDim[i];
-//    ssize *= gridAxisGlobalDim[i];
-//  }
-//
-//  std::vector<size_t>::const_iterator itbArr = globalIndexGridDestSendToServer.begin(), itArr,
-//                                      iteArr = globalIndexGridDestSendToServer.end();
-//
-//  while (idx < ssize)
-//  {
-//    for (int i = 0; i < globalDim-1; ++i)
-//    {
-//      if (idxLoop[i] == gridAxisGlobalDim[i])
-//      {
-//        idxLoop[i] = 0;
-//        ++idxLoop[i+1];
-//      }
-//    }
-//
-//    for (int i = 0; i < globalDim; ++i) currentIndex[i] = idxLoop[i];
-//    currentIndex[axisPositionInGrid] = axisDestGlobalIndex;
-//
-//    size_t globIndex = currentIndex[0];
-//    size_t mulDim = 1;
-//    for (int k = 1; k < globalDim; ++k)
-//    {
-//      mulDim *= gridDestGlobalDim[k-1];
-//      globIndex += (currentIndex[k])*mulDim;
-//    }
-//
-//    if (std::binary_search(itbArr, iteArr, globIndex)) ++realGlobalIndexSize;
-//    ++idxLoop[0];
-//    ++idx;
-//  }
-//
-//  if (globalIndexDestGrid.numElements() != realGlobalIndexSize)
-//    globalIndexDestGrid.resize(realGlobalIndexSize);
-//
-//  if (realGlobalIndexSize != globalIndexSrcGrid.size()) globalIndexSrcGrid.resize(realGlobalIndexSize);
-//  for (int i = 0; i < globalIndexSrcGrid.size(); ++i)
-//    if (globalIndexSrcGrid[i].size() != axisSrcGlobalIndex.size())
-//      globalIndexSrcGrid[i].resize(axisSrcGlobalIndex.size());
-//
-//  size_t realGlobalIndex = 0;
-//  idx = 0;
-//  idxLoop.assign(globalDim, 0);
-//  while (idx < ssize)
-//  {
-//    for (int i = 0; i < globalDim-1; ++i)
-//    {
-//      if (idxLoop[i] == gridAxisGlobalDim[i])
-//      {
-//        idxLoop[i] = 0;
-//        ++idxLoop[i+1];
-//      }
-//    }
-//
-//    for (int i = 0; i < globalDim; ++i) currentIndex[i] = idxLoop[i];
-//    currentIndex[axisPositionInGrid] = axisDestGlobalIndex;
-//
-//    size_t globIndex = currentIndex[0];
-//    size_t mulDim = 1;
-//    for (int k = 1; k < globalDim; ++k)
-//    {
-//      mulDim *= gridDestGlobalDim[k-1];
-//      globIndex += (currentIndex[k])*mulDim;
-//    }
-//
-//    if (std::binary_search(itbArr, iteArr, globIndex))
-//    {
-//      globalIndexDestGrid(realGlobalIndex) = globIndex;
-//      for (int i = 0; i < globalIndexSrcGrid[realGlobalIndex].size(); ++i)
-//      {
-//        currentIndex[axisPositionInGrid] = axisSrcGlobalIndex[i];
-//        globIndex = currentIndex[0];
-//        mulDim = 1;
-//        for (int k = 1; k < globalDim; ++k)
-//        {
-//          mulDim *= gridDestGlobalDim[k-1];
-//          globIndex += (currentIndex[k])*mulDim;
-//        }
-//        (globalIndexSrcGrid[realGlobalIndex])[i] = globIndex;
-//      }
-//      ++realGlobalIndex;
-//    }
-//
-//    ++idxLoop[0];
-//    ++idx;
-//  }
 }
 }
Index: XIOS/trunk/src/transformation/axis_algorithm_transformation.hpp
===================================================================
--- XIOS/trunk/src/transformation/axis_algorithm_transformation.hpp	(revision 828)
+++ XIOS/trunk/src/transformation/axis_algorithm_transformation.hpp	(revision 829)
@@ -33,6 +33,6 @@
                                                         const std::vector<int>& gridDestGlobalDim,
                                                         const std::vector<int>& gridSrcGlobalDim,
-                                                        const std::vector<size_t>& globalIndexGridDestSendToServer,
-                                                        CArray<size_t,1>& globalIndexDestGrid,
+                                                        const GlobalLocalMap& globalLocalIndexDestSendToServerMap,
+                                                        std::vector<std::pair<size_t,int> >& globalLocalIndexDestMap,
                                                         std::vector<std::vector<size_t> >& globalIndexSrcGrid);
 
Index: XIOS/trunk/src/transformation/domain_algorithm_interpolate.cpp
===================================================================
--- XIOS/trunk/src/transformation/domain_algorithm_interpolate.cpp	(revision 828)
+++ XIOS/trunk/src/transformation/domain_algorithm_interpolate.cpp	(revision 829)
@@ -417,5 +417,5 @@
 
   domainIndexClientClientMapping.computeServerIndexMapping(globalIndexInterp);
-  const std::map<int, std::vector<size_t> >& globalIndexInterpSendToClient = domainIndexClientClientMapping.getGlobalIndexOnServer();
+  const CClientServerMapping::GlobalIndexMap& globalIndexInterpSendToClient = domainIndexClientClientMapping.getGlobalIndexOnServer();
 
   //Inform each client number of index they will receive
@@ -429,6 +429,6 @@
   }
   int sendBuffSize = 0;
-  std::map<int, std::vector<size_t> >::const_iterator itbMap = globalIndexInterpSendToClient.begin(), itMap,
-                                                      iteMap = globalIndexInterpSendToClient.end();
+  CClientServerMapping::GlobalIndexMap::const_iterator itbMap = globalIndexInterpSendToClient.begin(), itMap,
+                                                       iteMap = globalIndexInterpSendToClient.end();
   for (itMap = itbMap; itMap != iteMap; ++itMap)
   {
Index: XIOS/trunk/src/transformation/domain_algorithm_transformation.cpp
===================================================================
--- XIOS/trunk/src/transformation/domain_algorithm_transformation.cpp	(revision 828)
+++ XIOS/trunk/src/transformation/domain_algorithm_transformation.cpp	(revision 829)
@@ -42,6 +42,6 @@
                                                                           const std::vector<int>& gridDestGlobalDim,
                                                                           const std::vector<int>& gridSrcGlobalDim,
-                                                                          const std::vector<size_t>& globalIndexGridDestSendToServer,
-                                                                          CArray<size_t,1>& globalIndexDestGrid,
+                                                                          const GlobalLocalMap& globalLocalIndexDestSendToServerMap,
+                                                                          std::vector<std::pair<size_t,int> >& globalLocalIndexDestMap,
                                                                           std::vector<std::vector<size_t> >& globalIndexSrcGrid)
 {
@@ -79,6 +79,6 @@
   for (int i = 0; i< numElement; ++i) ssize *= gridDomainGlobalDim[i];
 
-  std::vector<size_t>::const_iterator itbArr = globalIndexGridDestSendToServer.begin(), itArr,
-                                      iteArr = globalIndexGridDestSendToServer.end();
+  GlobalLocalMap::const_iterator iteArr = globalLocalIndexDestSendToServerMap.end(), it;
+
   idx = 0;
   while (idx < ssize)
@@ -112,11 +112,11 @@
     }
 
-    if (std::binary_search(itbArr, iteArr, globIndex)) ++realGlobalIndexSize;
+    if (iteArr != globalLocalIndexDestSendToServerMap.find(globIndex)) ++realGlobalIndexSize;
     ++idxLoop[0];
     ++idx;
   }
 
-  if (globalIndexDestGrid.numElements() != realGlobalIndexSize)
-    globalIndexDestGrid.resize(realGlobalIndexSize);
+  if (globalLocalIndexDestMap.size() != realGlobalIndexSize)
+    globalLocalIndexDestMap.resize(realGlobalIndexSize);
 
   if (realGlobalIndexSize != globalIndexSrcGrid.size()) globalIndexSrcGrid.resize(realGlobalIndexSize);
@@ -158,7 +158,8 @@
     }
 
-    if (std::binary_search(itbArr, iteArr, globIndex))
+    it = globalLocalIndexDestSendToServerMap.find(globIndex);
+    if (iteArr != it)
     {
-      globalIndexDestGrid(realGlobalIndex) = globIndex;
+      globalLocalIndexDestMap[realGlobalIndex] = (std::make_pair(it->first,it->second));
       for (int i = 0; i < globalIndexSrcGrid[realGlobalIndex].size(); ++i)
       {
Index: XIOS/trunk/src/transformation/domain_algorithm_transformation.hpp
===================================================================
--- XIOS/trunk/src/transformation/domain_algorithm_transformation.hpp	(revision 828)
+++ XIOS/trunk/src/transformation/domain_algorithm_transformation.hpp	(revision 829)
@@ -33,6 +33,6 @@
                                                         const std::vector<int>& gridDestGlobalDim,
                                                         const std::vector<int>& gridSrcGlobalDim,
-                                                        const std::vector<size_t>& globalIndexGridDestSendToServer,
-                                                        CArray<size_t,1>& globalIndexDestGrid,
+                                                        const GlobalLocalMap& globalLocalIndexDestSendToServerMap,
+                                                        std::vector<std::pair<size_t,int> >& globalLocalIndexDestMap,
                                                         std::vector<std::vector<size_t> >& globalIndexSrcGrid);
 
Index: XIOS/trunk/src/transformation/generic_algorithm_transformation.cpp
===================================================================
--- XIOS/trunk/src/transformation/generic_algorithm_transformation.cpp	(revision 828)
+++ XIOS/trunk/src/transformation/generic_algorithm_transformation.cpp	(revision 829)
@@ -3,5 +3,5 @@
    \author Ha NGUYEN
    \since 14 May 2015
-   \date 29 June 2015
+   \date 21 Mars 2016
 
    \brief Interface for all transformation algorithms.
@@ -23,6 +23,7 @@
   \param[in] gridSrcGlobalDim dimension size of source grid (it should share the same size for all dimension, maybe except the domain on which transformation is performed)
   \param[in] globalIndexGridDestSendToServer global index of grid destination on the current client to send to server
+  \param[in] localIndexGridSendToServer local index of grid destination on the current client to send to server
   \param[in/out] globaIndexWeightFromDestToSource mapping between transformed global index of grid destination
-             and the weighted value as long as global index from grid index source
+             and the weighted value as well as global index from grid index source
 */
 void CGenericAlgorithmTransformation::computeGlobalSourceIndex(int elementPositionInGrid,
@@ -30,9 +31,15 @@
                                                              const std::vector<int>& gridSrcGlobalDim,
                                                              const std::vector<size_t>& globalIndexGridDestSendToServer,
-                                                             std::map<size_t, std::vector<std::pair<size_t,double> > >& globaIndexWeightFromDestToSource)
+                                                             const std::vector<int>& localIndexGridSendToServer,
+                                                             DestinationIndexMap& globaIndexWeightFromDestToSource)
 {
   bool isTransPosEmpty = transformationPosition_.empty();
-  std::vector<size_t> vecGlobalIndexGridSendToServer(globalIndexGridDestSendToServer.begin(), globalIndexGridDestSendToServer.end());
-  std::sort(vecGlobalIndexGridSendToServer.begin(), vecGlobalIndexGridSendToServer.end());
+  boost::unordered_map<size_t,int> globalLocalIndexDestSendToServerMap;
+  size_t nbGlobalIndexDest = globalIndexGridDestSendToServer.size();
+  for (size_t idx = 0; idx < nbGlobalIndexDest; ++idx)
+  {
+    globalLocalIndexDestSendToServerMap[globalIndexGridDestSendToServer[idx]] = localIndexGridSendToServer[idx];
+  }
+
   for (size_t idxTrans = 0; idxTrans < transformationMapping_.size(); ++idxTrans)
   {
@@ -51,20 +58,19 @@
 
     std::vector<std::vector<size_t> > globalIndexSrcGrid;
-    CArray<size_t,1> globalIndexDestGrid;
-//    std::vector<size_t> vecGlobalIndexGridSendToServer(globalIndexGridDestSendToServer.begin(), globalIndexGridDestSendToServer.end());
-//    std::sort(vecGlobalIndexGridSendToServer.begin(), vecGlobalIndexGridSendToServer.end());
+    std::vector<std::pair<size_t,int> > globalLocalIndexDest;
     for (itTransMap = itbTransMap; itTransMap != iteTransMap; ++itTransMap, ++itTransWeight)
     {
+      boost::unordered_map<size_t,int> globalLocalIndexDestMap;
       if (!isTransPosEmpty)
       {
         this->computeGlobalGridIndexFromGlobalIndexElement(itTransMap->first,
-                                                       itTransMap->second,
-                                                       itTransPos->second,
-                                                       elementPositionInGrid,
-                                                       gridDestGlobalDim,
-                                                       gridSrcGlobalDim,
-                                                       vecGlobalIndexGridSendToServer,
-                                                       globalIndexDestGrid,
-                                                       globalIndexSrcGrid);
+                                                           itTransMap->second,
+                                                           itTransPos->second,
+                                                           elementPositionInGrid,
+                                                           gridDestGlobalDim,
+                                                           gridSrcGlobalDim,
+                                                           globalLocalIndexDestSendToServerMap,
+                                                           globalLocalIndexDest,
+                                                           globalIndexSrcGrid);
         ++itTransPos;
       }
@@ -72,21 +78,23 @@
       {
         this->computeGlobalGridIndexFromGlobalIndexElement(itTransMap->first,
-                                                       itTransMap->second,
-                                                       emptyTransPos,
-                                                       elementPositionInGrid,
-                                                       gridDestGlobalDim,
-                                                       gridSrcGlobalDim,
-                                                       vecGlobalIndexGridSendToServer,
-                                                       globalIndexDestGrid,
-                                                       globalIndexSrcGrid);
+                                                           itTransMap->second,
+                                                           emptyTransPos,
+                                                           elementPositionInGrid,
+                                                           gridDestGlobalDim,
+                                                           gridSrcGlobalDim,
+                                                           globalLocalIndexDestSendToServerMap,
+                                                           globalLocalIndexDest,
+                                                           globalIndexSrcGrid);
       }
-      size_t globalIndexSize = globalIndexDestGrid.numElements();
+      std::vector<std::pair<size_t,int> >::const_iterator it = globalLocalIndexDest.begin(), ite = globalLocalIndexDest.end();
       const std::vector<double>& currentVecWeight = itTransWeight->second;
-      for (size_t idx = 0; idx < globalIndexSize; ++idx)
+
+      for (size_t idx = 0; it != ite; ++it, ++idx)
       {
-        size_t globalIndex = globalIndexDestGrid(idx);
-        for (int i = 0; i < globalIndexSrcGrid[idx].size(); ++i)
+        size_t srcGridSize = globalIndexSrcGrid[idx].size();
+        globaIndexWeightFromDestToSource[(it->first)].reserve(srcGridSize);
+        for (int i = 0; i < srcGridSize; ++i)
         {
-          globaIndexWeightFromDestToSource[globalIndex].push_back(make_pair(globalIndexSrcGrid[idx][i], currentVecWeight[i]));
+          globaIndexWeightFromDestToSource[(it->first)].push_back(make_pair(it->second, make_pair(globalIndexSrcGrid[idx][i], currentVecWeight[i])));
         }
       }
Index: XIOS/trunk/src/transformation/generic_algorithm_transformation.hpp
===================================================================
--- XIOS/trunk/src/transformation/generic_algorithm_transformation.hpp	(revision 828)
+++ XIOS/trunk/src/transformation/generic_algorithm_transformation.hpp	(revision 829)
@@ -22,4 +22,11 @@
 {
 public:
+  // Stupid global index map, it must be replaced by tuple
+  // Mapping between global index map of DESTINATION and its local index with pair of global index of SOURCE and weights
+  typedef boost::unordered_map<size_t, std::vector<std::pair<int, std::pair<size_t,double> > > > DestinationIndexMap;
+protected:
+  typedef boost::unordered_map<size_t,int> GlobalLocalMap;
+
+public:
   CGenericAlgorithmTransformation();
 
@@ -30,5 +37,6 @@
                                 const std::vector<int>& gridSrcGlobalDim,
                                 const std::vector<size_t>& globalIndexGridDestSendToServer,
-                                std::map<size_t, std::vector<std::pair<size_t,double> > >& globaIndexWeightFromDestToSource);
+                                const std::vector<int>& localIndexGridSendToServer,
+                                DestinationIndexMap& globaIndexWeightFromDestToSource);
 
   std::vector<StdString> getIdAuxInputs();
@@ -46,6 +54,6 @@
     \param[in] elementPositionInGrid position of the element in the grid (for example: a grid with one domain and one axis, position of domain is 1, position of axis is 2)
     \param[in] gridDestGlobalDim dimension size of destination grid (it should share the same size for all dimension, maybe except the element on which transformation is performed)
-    \param[in] globalIndexGridDestSendToServer global index of destination grid which are to be sent to server(s), this array is already acsending sorted
-    \param[in/out] globalIndexDestGrid array of global index (for 2d grid, this array maybe a line, for 3d, this array may represent a plan). It should be preallocated
+    \param[in] globalLocalIndexDestSendToServerMap pair of global index and local index of destination grid which are to be sent to server(s), this array is already acsending sorted
+    \param[in/out] globalLocalIndexDestMap array of global index (for 2d grid, this array maybe a line, for 3d, this array may represent a plan). It should be preallocated
     \param[in/out] globalIndexSrcGrid array of global index of source grid (for 2d grid, this array is a line, for 3d, this array represents a plan). It should be preallocated
   */
@@ -56,6 +64,6 @@
                                                         const std::vector<int>& gridDestGlobalDim,
                                                         const std::vector<int>& gridSrcGlobalDim,
-                                                        const std::vector<size_t>& globalIndexGridDestSendToServer,
-                                                        CArray<size_t,1>& globalIndexDestGrid,
+                                                        const GlobalLocalMap& globalLocalIndexDestSendToServerMap,
+                                                        std::vector<std::pair<size_t,int> >& globalLocalIndexDestMap,
                                                         std::vector<std::vector<size_t> >& globalIndexSrcGrid) = 0;
 
